# MAIN IMPORTS ================================================================================================================================================= #
import psyco
psyco.full()
import es
import playerlib
# ============================================================================================================================================================== #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

def load():
	### CREATE PLAYERS VAR ###
	for ply in playerlib.getPlayerList('#all'):
		var = es.ServerVar('sam_noclip_%s' % ply.steamid)
		var.set(0)

# ============================================================================================================================================================== #
# ========================================================================= UNLOAD ============================================================================= #
# ============================================================================================================================================================== #
def unload():
	### UNCLIP PLAYERS ###
	for ply in playerlib.getPlayerList('#all'):
		targetvar = es.ServerVar('sam_noclip_%s' % ply.steamid)
		if int(targetvar) == 1: unclip(ply)

# ============================================================================================================================================================== #
# ======================================================================= MAIN BLOCKS ========================================================================== #
# ============================================================================================================================================================== #
def moduleAction(userid, target):
	if admins.checkImmunity(es.getplayersteamid(userid), target.steamid):
		targetvar = es.ServerVar('sam_noclip_%s' % target.steamid)
		if int(targetvar) != 1:
			clip(target)
			func.tell('#all', func.lang_pcontrol('noclip_target_cliped', {'target':target.name}))
		else:
			unclip(target)
			func.tell('#all', func.lang_pcontrol('noclip_target_uncliped', {'target':target.name}))
	block = es.import_addon('sam/base/pcontrol')
	block.function(userid, 'Noclip', None)

# ============================================================================================================================================================== #
# ======================================================================== FUNCTIONS =========================================================================== #
# ============================================================================================================================================================== #
def clip(target):
	targetvar = es.ServerVar('sam_noclip_%s' % target.steamid)
	targetvar.set(1)
	target.noclip(1)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def unclip(target):
	targetvar = es.ServerVar('sam_noclip_%s' % target.steamid)
	targetvar.set(0)
	target.noclip(0)

# ============================================================================================================================================================== #
# ========================================================================= EVENTS ============================================================================= #
# ============================================================================================================================================================== #
def player_activate(ev):
	var = es.ServerVar('sam_noclip_%s' % ev['userid'])
	var.set(0)

# ============================================================================================================================================================== #