# MAIN IMPORTS ================================================================================================================================================= #
import psyco
psyco.full()
import es
import playerlib
import usermsg
import gamethread
# ============================================================================================================================================================== #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

def load():
	### CREATE PLAYERS VAR ###
	for ply in playerlib.getPlayerList('#all'):
		var = es.ServerVar('sam_blind_%s' % ply.steamid)
		var.set(0)

# ============================================================================================================================================================== #
# ========================================================================= UNLOAD ============================================================================= #
# ============================================================================================================================================================== #
def unload():
	### UNCLIP PLAYERS ###
	for ply in playerlib.getPlayerList('#all'):
		targetvar = es.ServerVar('sam_blind_%s' % ply.steamid)
		if int(targetvar) == 1: unblind(ply)

# ============================================================================================================================================================== #
# ======================================================================= MAIN BLOCKS ========================================================================== #
# ============================================================================================================================================================== #
def moduleAction(userid, target):
	if admins.checkImmunity(es.getplayersteamid(userid), target.steamid):
		targetvar = es.ServerVar('sam_blind_%s' % target.steamid)
		if int(targetvar) != 1:
			blind(target)
			func.tell('#all', func.lang_pcontrol('blind_target_blinded', {'target':target.name}))
		else:
			unblind(target)
			func.tell('#all', func.lang_pcontrol('blind_target_unblinded', {'target':target.name}))
	block  = es.import_addon('sam/base/pcontrol')
	block.function(userid, 'Blind', None)

# ============================================================================================================================================================== #
# ======================================================================== FUNCTIONS =========================================================================== #
# ============================================================================================================================================================== #
def blind(target):
	targetvar = es.ServerVar('sam_blind_%s' % target.steamid)
	targetvar.set(1)
	usermsg.fade(target, 0, 1, 1000, 0, 0, 0)
	gamethread.delayedname(1, 'sam_blind_%s' % target, blind, (target))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def unblind(target):
	targetvar = es.ServerVar('sam_blind_%s' % target.steamid)
	targetvar.set(0)
	gamethread.cancelDelayed('sam_blind_%s' % target)

# ============================================================================================================================================================== #
# ========================================================================= EVENTS ============================================================================= #
# ============================================================================================================================================================== #
def player_activate(ev):
	var = es.ServerVar('sam_blind_%s' % ev['userid'])
	var.set(0)

# ============================================================================================================================================================== #