# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import gamethread
import usermsg
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(userid, target):
	if admins.checkImmunity(es.getplayersteamid(userid), target.steamid):
		func.tell('#all', func.lang_pcontrol('firework_target', {'target':target.name}))
		func.sound(target, 'weapons\physgun_off.wav', 1, 0.5)
		shake(target, 2, 100)
		gamethread.delayedname(0.1, 'sam_firework_%s' % target, push, (target, 20))
		gamethread.delayedname(0.2, 'sam_firework_%s' % target, push, (target, 45))
		gamethread.delayedname(0.3, 'sam_firework_%s' % target, push, (target, 80))
		gamethread.delayedname(0.4, 'sam_firework_%s' % target, push, (target, 125))
		gamethread.delayedname(0.5, 'sam_firework_%s' % target, push, (target, 180))
		gamethread.delayedname(0.6, 'sam_firework_%s' % target, push, (target, 245))
		gamethread.delayedname(0.7, 'sam_firework_%s' % target, push, (target, 320))
		gamethread.delayedname(0.8, 'sam_firework_%s' % target, push, (target, 405))
		gamethread.delayedname(0.9, 'sam_firework_%s' % target, push, (target, 500))
		gamethread.delayedname(1.6, 'sam_firework_%s' % target, func.sound, (target, 'weapons\c4\c4_beep1.wav', 1, 0.5))
		gamethread.delayedname(1.7, 'sam_firework_%s' % target, func.sound, (target, 'weapons\c4\c4_beep1.wav', 1, 0.5))
		gamethread.delayedname(1.9, 'sam_firework_%s' % target, explosion, (target))
		gamethread.delayedname(1.9, 'sam_firework_%s' % target, func.sound, (target, 'weapons/hegrenade/explode4.wav', 1, 0.5))
		gamethread.delayedname(1.9, 'sam_firework_%s' % target, kill, (target))
	block = es.import_addon('sam/base/pcontrol')
	block.function(userid, 'Firework', None)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def explosion(target):
	if target.isdead == 0:
		x,y,z = es.getplayerlocation(target)
		es.server.queuecmd('es_xeffect sparks %s,%s,%s 9999 3 0,0,0' % (x, y, z))

# ============================================================================================================================================================ #
def kill(target):
	if target.isdead == 0: target.slay()

# ============================================================================================================================================================ #
def push(target, push):
	if target.isdead == 0: es.setplayerprop(target, 'CCSPlayer.baseclass.localdata.m_vecBaseVelocity', '0,0,%s' % (push))

# ============================================================================================================================================================ #
def shake(target, time, magnitude):
	if target.isdead == 0: es.server.queuecmd('usermsg shake %s %s %s' % (target, magnitude, time))

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def player_death(ev): gamethread.cancelDelayed('sam_firework_%s' % ev['userid'])

# ============================================================================================================================================================= #
