# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import playerlib
import popuplib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')
block  = es.import_addon('sam/base/pcontrol')

# * VARIABLES
values = [0,800,2800,5000,10000,16000]

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### POPUPS ###
	func.popupDelete('get_targets')
	func.popupDelete('get_cash')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(userid):
	func.popupDelete('get_targets')
	popup = popuplib.easymenu('get_targets', None, getTargets)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
	popup.setdescription('\n \n :: %s\n # %s' % (func.lang_titles('pcontrol_givecash'),func.lang_titles('pcontrol_givecash_howmuch_desc')))
	popup.addoption('all', func.lang_pcontrol('givecash_giveto_all'))
	for ply in playerlib.getPlayerList('#alive'): popup.addoption(ply, ply.name)
	popup.submenu(10, 'pcontrol')
	popup.send(userid)

# ============================================================================================================================================================= #
def getTargets(userid, choice, popup):
	func.popupDelete('get_cash')
	popup = popuplib.easymenu('get_cash', None, give_cash)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
	popup.setdescription('\n \n :: %s\n # %s' % (func.lang_titles('pcontrol_givecash'),func.lang_titles('pcontrol_givecash_howmuch_desc')))
	num = 0
	while num < 16800:
		popup.addoption({'cash':num,'target':choice}, num)
		num += 800
	popup.submenu(10, 'get_targets')
	popup.send(userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def give_cash(userid, choice, popup):
	if choice['target'] == 'all':
		for player in playerlib.getPlayerList('#all'):
			if admins.checkImmunity(es.getplayersteamid(userid), player.steamid, 0): player.setCash(int(choice['cash']))
		func.tell('#all', func.lang_pcontrol('givecash_to_all', choice))
		block.modulePopup(userid)
	else:
		target = choice['target']
		target.setCash(int(choice['cash']))
		func.tell('#all', func.lang_pcontrol('givecash_to_target', {'target':target.name,'cash':choice['cash']}))
		block.function(userid, 'Give Cash', None)

# ============================================================================================================================================================= #