# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import playerlib
import popuplib
import cmdlib
import langlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

kicktag = '#greenKICK'

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load(): cmdlib.registerSayCommand('!kick', kickCMD, 'SAM')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload(): cmdlib.unregisterSayCommand('!kick')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def kickCMD(userid, args):
	steamid = es.getplayersteamid(userid)
	if admins.isAdmin(steamid):
		if admins.checkAccess(steamid, 'Kick'):
			if args:
				if len(args) == 1:
					if es.exists('userid', es.getuserid(args[0])): moduleAction(playerlib.getPlayer(userid), playerlib.getPlayer(es.getuserid(args[0])), 1)
					else: func.hudhint(userid, func.lang_pcontrol('target_not_exist', {'target':args[0]}), 'KICK')
				elif len(args) > 1:
					targets = len(args)
					for x in args:
						if es.exists('userid', es.getuserid(x)):
							target = playerlib.getPlayer(es.getuserid(x))
							if admins.checkImmunity(steamid, target.steamid): target.kick(reason=func.lang_pcontrol('kick_kicked_msg'))
							else: targets -= 1
						else: targets -= 1
					if targets > 0: func.tell('#human', func.lang_pcontrol('kick_multi_targets', {'num':targets}), kicktag)
			else:
				block = es.import_addon('sam/base/pcontrol')
				block.function(userid, 'Kick', None)

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(admin, target, rcmd = None):
	if admins.checkImmunity(admin.steamid, target.steamid):
		target.kick(reason=func.lang_pcontrol('kick_kicked_msg'))
		func.tell('#human', func.lang_pcontrol('kick_one_target', {'target':target.name}), kicktag)
	if rcmd == None:
		block = es.import_addon('sam/base/pcontrol')
		block.function(admin, 'Kick', None)

# ============================================================================================================================================================= #