# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import popuplib
import random
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### POPUPS ###
	func.popupDelete('slap_dmg')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(userid, target):
	if admins.checkImmunity(es.getplayersteamid(userid), target.steamid):
		func.popupDelete('slap_dmg')
		popup = popuplib.easymenu('slap_dmg', None, slap)
		popup.c_beginsep = func.pline
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: %s\n # %s' % (func.lang_titles('pcontrol_slap'),func.lang_titles('pcontrol_slap_desc')))
		popup.addoption({'target':target,'dmg':0}, func.lang_pcontrol('slap_nodamage'))
		num = 10
		while num < 105:
			popup.addoption({'target':target,'dmg':num}, num)
			num += 10
		popup.submenu(10, 'pcontrol')
		popup.send(userid)
	else:
		block  = es.import_addon('sam/base/pcontrol')
		block.function(userid, 'Slap', None)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def slap(userid, choice, popup):
	target = choice['target']
	dmg    = choice['dmg']
	x = random.randint(-100, 100)
	y = random.randint(-100, 100)
	z = random.randint(100, 300)
	if not target.isdead:
		func.sound(target, 'player/damage%s.wav' % random.randint(1,3), 1, 0.2)
		es.setplayerprop(target, 'CCSPlayer.baseclass.localdata.m_vecBaseVelocity', es.createvectorstring(x,y,z))
		target.setHealth(target.getHealth() - dmg)
		string = str(target.getHealth())
		if target.getHealth() == 0 or string.startswith('-'): target.slay()
		func.tell('#all', func.lang_pcontrol('slap_target_slaped', {'target':target.name}))
	else: func.hudhint(userid, func.lang_pcontrol('slay_target_is_dead', {'target':target.name}), 'SLAP')
	moduleAction(userid, playerlib.getPlayer(target))

# ============================================================================================================================================================= #
